	include	"flib.h"
	include	"tios.h"
	include	"mzlib.h"
	xdef	_main
	xdef	_comment

_main:
	jsr flib::zap_screen
	move.w #1,-(a7)
	jsr tios::FontSetSys
	move.w #4,-(a7)
	pea _comment(pc)
	move.l #$200030,-(a7)
	jsr tios::DrawStrXY
	lea 12(a7),a7
	jsr flib::idle_loop
start:
	lea pcs(pc),a0
	lea scr(pc),a1
	clr.l (a1)
	clr.l 4(a1)
	clr.l 8(a1)
	clr.l 12(a1)
	lea piece(pc),a2
	jsr flib::zap_screen
next_p:
	btst.b #3,(a1)
	bne exit
	btst.b #4,(a1)
	bne exit
	clr.w d7
	move.w #7,d0
	jsr flib::random
	lsl.w #2,d0
	move.l 0(a0,d0.w),(a2)
	bsr draw_p
	move.w #$f000,d5
getkey:
	subi.w #1,d5
	beq down
	tst.w ($75b0)
	beq getkey
	move.w ($75B2),d0
	clr.w ($75B0)
	cmpi.w #337,d0
	beq left
	cmpi.w #340,d0
	beq right
	cmpi.w #344,d0
	beq down
	bclr.l #31,d0
	cmpi.w #268,d0
	beq turn_r
	cmpi.w #272,d0
	beq turn_l
	cmpi.w #264,d0
	beq exit
	cmpi.w #13,d0	;Pause
	bne getkey
	jsr flib::idle_loop
	bra getkey
down:
	bsr draw_p
	move.l (a2),d1
b:
	move.b d1,d2
	move.b d1,d3
	and.w #7,d3
	eor.w #7,d3
	and.w #$f8,d2
	lsr.w #3,d2
	cmpi.w #$f,d2
	beq bottom
	btst.b d3,1(a1,d2.w)
	bne bottom
	lsr.l #8,d1
	tst.l d1
	bne b
;	jsr mzlib::check
	addi.l #$08080808,(a2)
	bsr draw_p
	move.w #$f000,d5
	bra getkey
bottom:
	bsr draw_p
	move.w #$f,d0
check_r:
	cmpi.b #$ff,0(a1,d0.w)
	beq clr_row
	subi.w #1,d0
	beq next_p
	bra check_r
clr_row:
	move.w d0,d1
	move.l #$4440,a3
	move.w d0,d2
	mulu #$f0,d2
	add.w d2,a3
row_down:
	subi.w #1,d1
	blt no_row
	move.b 0(a1,d1.w),1(a1,d1.w)
	move.b #8,d4
pic_down1:
	lea -22(a3),a3
	move.b #2,d3
pic_down2:
	move.l -(a3),240(a3)
	subi.b #1,d3
	bne pic_down2
	subi.b #1,d4
	bne pic_down1
	bra row_down
no_row:
	move.w #32,d3
clr_pic:
	clr.l (a3)+
	subi.b #1,d3
	bne clr_pic
	clr.b (a1)
	bra check_r
right:
	bsr draw_p
	move.l (a2),d1
c:
	move.b d1,d2
	move.b d1,d3
	and.w #7,d3
	eor.w #7,d3
	and.w #$f8,d2
	lsr.w #3,d2
	tst.w d3
	beq no_r
	subi.w #1,d3
	btst.b d3,0(a1,d2.w)
	bne no_r
	lsr.l #8,d1
	tst.l d1
	bne c
	addi.l #$01010101,(a2)
	bsr draw_p
	bra getkey
no_r:
	bsr draw_p
	bra getkey
left:
	bsr draw_p
	move.l (a2),d1
d:
	move.b d1,d2
	move.b d1,d3
	and.w #7,d3
	tst.w d3
	beq no_l
	eor.w #7,d3
	and.w #$f8,d2
	lsr.w #3,d2
	addi.w #1,d3
	btst.b d3,0(a1,d2.w)
	bne no_l
	lsr.l #8,d1
	tst.l d1
	bne d
	subi.l #$01010101,(a2)
	bsr draw_p
	bra getkey
no_l:
	bsr draw_p
	bra getkey
turn_r:
	bset.l #31,d0
turn_l:
	bsr draw_p
	move.l (a2),d6
	move.b (a2),d0
	move.b 3(a2),d2
	move.b d0,d1
	move.b d2,d3
	andi.w #7,d0
	andi.w #7,d2
	andi.w #$f8,d1
	andi.w #$f8,d3
	lsr.w #3,d1
	lsr.w #3,d3
	add.w d2,d0
	add.w d3,d1
	bchg.l #0,d7
	move.w #3,d2
turn:
	move.b 0(a2,d2.w),d3	;y-coordinate
	move.b 0(a2,d2.w),d4	;x-coordinate
	andi.w #7,d4
	lsl.w #1,d4
	andi.w #$f8,d3
	lsr.w #2,d3
	sub.w d0,d4
	sub.w d1,d3
	exg d3,d4
	neg.w d3
	btst.l #31,d0
	beq true
	neg.w d3
	neg.w d4
true:
	add.w d1,d3
	add.w d7,d3
	lsr.w #1,d3
	add.w d0,d4
	add.w d7,d4
	lsr.w #1,d4
	cmpi.w #0,d4
	blt no_t
	cmpi.w #7,d4
	bgt no_t
	eor.b #7,d4
	btst.b d4,0(a1,d3.w)
	bne no_t
	eor.b #7,d4
	lsl.w #3,d3
	add.w d3,d4
	move.b d4,0(a2,d2.w)
	subi.w #1,d2
	bge turn
	bsr draw_p
	bra getkey
no_t:
	move.l d6,(a2)
	bsr draw_p
	bra getkey
exit:
	rts

draw_p:
	move.l (a2),d1
a:
	lea block(pc),a3
	move.l #$4440,a4
	move.b d1,d2
	move.b d1,d3
	and.w #%111,d3
	add.w d3,a4
	eor.w #%111,d3
	and.w #$f8,d2
	lsr.w #3,d2
	bchg.b d3,0(a1,d2.w)
	mulu #240,d2
	add.w d2,a4
	move.b #8,d4
sloop:
	move.b (a3)+,d3
	eor.b d3,(a4)
	lea 30(a4),a4
	subi.b #1,d4
	bne sloop
	lsr.l #8,d1
	tst.l d1
	bne a
	rts

scr:	ds.l 4

pcs:
	dc.l $030b131b
;0100	0000
;0100	1111
;0100	0000
;0100	0000
	dc.l $03040b13
;0000	0000	0000	0010
;0100	0110	1110	0010
;0111	0100	0010	0110
;0000	0100	0000	0000
	dc.l $03040c14
;0000	0000	0000	0100
;0111	0110	0010	0100
;0100	0010	1110	0110
;0000	0010	0000	0000
	dc.l $030b0c14
;0000	0100
;0110	0110
;1100	0010
;0000	0000
	dc.l $040b0c13
;0010	0000
;0110	1100
;0100	0110
;0000	0000
	dc.l $030b0c13
;0100	0000	0000	0000
;0110	0111	0010	0100
;0100	0010	0110	1110
;0000	0000	0010	0000
	dc.l $03040b0c
;0000
;0110
;0110
;0000

piece:
	ds.l 1

block:
	dc.b    %01111111
	dc.b    %01000001
	dc.b    %01011101
	dc.b    %01010101
	dc.b    %01011101
	dc.b    %01000001
	dc.b    %01111111
	dc.b    %00000000

bomb:
	dc.b    %00001101
	dc.b    %00010010
	dc.b    %00001000
	dc.b    %00111110
	dc.b    %01111111
	dc.b    %01111111
	dc.b    %01111111
	dc.b    %00111110

_comment:	dc.b "TETRIS by Martin Zeppenfeld",0
	end